﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@

Sub Class_Globals
	Dim W As MLwifi
	Dim WScan As MLScan
	Dim WSCanDone As Boolean
	Dim ScanSuccess As Boolean = False
	
	Dim OldSSID As String = ""
	Dim NewSSID As String = ""
	Public CurrentSSID As String = ""
	
	Public IsInitialized As Boolean = False
	
	Dim ServerIp As String = "192.168.4.1"
	
	
	Type WifiStatusInfo(StatusValue As Int, _
							StatusString As String)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize

	WSCanDone = False
	WifiScan(NewSSID)
'	W.debug = True
	IsInitialized = True

End Sub

Public Sub GetSSID As String
	Return W.WifiSSID
End Sub

Public Sub WifiScan(SSID As String) As ResumableSub
	Try
		If Not(WSCanDone) Then
			WScan.startscan("WiFi", True)
			Wait For WiFi_ScanDone (Results() As String, Count As Int)
			Return CheckForAP(SSID)
		Else
			Log("Scan can only be done once")
		End If
	Catch
		Log("AA Scan: " & LastException)
	End Try
	WSCanDone = True
	Return False
End Sub

Sub CheckForAP(SSID As String) As Boolean

	Try
		For Each Entry In WScan.wifis 'list of Networks found
			Dim EntryInfo() As String = Regex.Split(",", Entry)
			If EntryInfo(0) = SSID Then
				Return True
			End If
		Next
	Catch
		Log("Check for AP: " & LastException)
	End Try
	Return False
End Sub

Public Sub WifiCheckAP(SSID As String)As ResumableSub
	If Not(WSCanDone) Then
		wait for WifiScan Complete '(result As Boolean)
	End If
	NewSSID = SSID
	WScan.updateWifiList

	Wait For WiFi_ScanDone(Results() As String, Count As Int) '15/12/20
	ScanSuccess = CheckForAP(SSID) 'Results, Count)

	Return ScanSuccess
End Sub

public Sub SetAP(APName As String, APPass As String, SecType As Int, Timeout As Int) As ResumableSub
	Try
		Dim p As Phone
		Dim AndroidVersion As Int = p.SdkVersion
		OldSSID = W.WifiSSID
		Select True
			Case AndroidVersion >= 29
				Log("Connect 29")
				W.connectWifiAP(APName, SecType, APPass, Timeout)
				wait for Wifi_ConnectionResult (SAP1 As Boolean)
			Case AndroidVersion = 28
				Log("Connect 28")
				W.connectWifiAP(APName, SecType, APPass, Timeout)
				wait for Wifi_ConnectionResult (SAP1 As Boolean)
			Case Else
				Log("<28, Save")
				W.saveWifiAP(APName, SecType, APPass, True, Timeout)
				Log("<28, connect")
				wait for Wifi_ConnectionResult (SAP1 As Boolean)
		End Select

		If SAP1 Then CurrentSSID = APName
		Return SAP1
	Catch
		Log("SetAp error: " & LastException)
	End Try
	Return False
End Sub

public Sub ResetAP As ResumableSub

	Log("RAP Old SSID = " & OldSSID)
	Dim p As Phone
	Dim AndroidVersion As Int = p.SdkVersion
	
	Select True
		Case AndroidVersion >= 29
			Log("29+ reset")
			
			Return w.disconnectWifiAP
			
'			W.reconnectWifiAP(OldSSID, 30000)
'			wait for Wifi_ConnectionResult (RAPResult2 As Boolean)

'			W.connectWifiAP(OldSSID, 0, "", 30000)
'			wait for Wifi_ConnectionResult (RAPResult2 As Boolean)
			
		Case AndroidVersion = 28
			
			Return w.disconnectWifiAP
			
'			W.reconnectWifiAP(OldSSID, 30000)
'			wait for Wifi_ConnectionResult (RAPResult2 As Boolean)

'			W.connectWifiAP(OldSSID, 0, "", 30000)
'			wait for Wifi_ConnectionResult (RAPResult2 As Boolean)
			
		Case Else
			Log("27- reset")
			W.reconnectWifiAP(OldSSID, 30000)
			wait for Wifi_ConnectionResult (RAPResult2 As Boolean)
			
	End Select
	
	Return RAPResult2
	
End Sub

